localStorage.removeItem('seenComments');
 chrome.storage.local.get(['selectedFeaturesph']).then(result => {
  console.log("我的视频号功能开关:", result.selectedFeaturesph);
}) ;
chrome.storage.local.get(['selectedFeaturedanmu']).then(result => {
  console.log("我的弹幕采集功能开关:", result.selectedFeaturedanmu);
}) ;
chrome.storage.local.get(['apikey'], (result) => {
  const savedApikey = result.apikey;
  console.log("我的apikey", savedApikey);


   // 链接评论转发专用域名的ws服务
 const ws = new WebSocket('wss://plzf.tingwu.co:8872');

 // 连接成功后发送认证信息
 ws.onopen = () => {
     ws.send(JSON.stringify({
         type: 'auth',
         apikey: result.apikey
     }));
 };

 // 接收消息
 ws.onmessage = (event) => {
     const data = JSON.parse(event.data);
     console.log('WSS收到消息:', data);
    
 };

 // 发送消息
 function sendMessage_ws(message) {
     if (ws.readyState === WebSocket.OPEN) {
         ws.send(JSON.stringify(message));
     }
 }

 // 确保updateLogArea函数在全局作用域中定义
 function updateLogArea(log, type = "信息") { // 默认类型为 "信息"
  const timestamp = new Date().toLocaleString("zh-CN", { hour12: false }).replace(/\//g, "-");
  const logWithTimestamp = `[${timestamp}] [${type}] ${log}`; // 添加时间戳和类型
  console.log("日志已更新:", logWithTimestamp);
  // 使用 chrome.storage.local 存储日志
  chrome.storage.local.get(['logs'], (result) => {
      let logs = result.logs || [];
      // 添加新日志
      logs.unshift(logWithTimestamp);
      // 限制最多存储50条日志
      if (logs.length > 50) {
          logs = logs.slice(0, 50);
      }
      // 更新本地存储
      chrome.storage.local.set({ logs: logs }, () => {
          // 发送消息到 popup.js
          chrome.runtime.sendMessage({ type: "log_show", log: logs });
          console.log("日志已更新:", logWithTimestamp);
      });
  });
}


 // 定期查询接口
 function queryServer() {
  console.log("查询服务器...");
  
  // 尝试在主文档中查找输入框
  let input = document.querySelector('.message-input');
  console.log("主文档中输入框:", input);
  
  // 如果主文档中没找到，尝试在所有iframe中查找
  if (!input) {
    const iframes = document.querySelectorAll('iframe');
    console.log("页面中iframe数量:", iframes.length);
    
    if (iframes.length > 0) {
      for (let i = 0; i < iframes.length; i++) {
        try {
          const frameDoc = iframes[i].contentDocument || iframes[i].contentWindow.document;
          const frameInput = frameDoc.querySelector('.message-input');
          console.log(`iframe[${i}]中输入框:`, frameInput);
          
          if (frameInput) {
            input = frameInput;
            console.log("在iframe中找到输入框");
            break;
          }
        } catch (e) {
          console.log(`无法访问iframe[${i}]内容:`, e.message);
        }
      }
    }
  }
  
  // 尝试查找Shadow DOM
  if (!input) {
    console.log("尝试在Shadow DOM中查找输入框");
    const shadowRoots = [];
    const getAllShadowRoots = (elements) => {
      elements.forEach(el => {
        if (el.shadowRoot) {
          shadowRoots.push(el.shadowRoot);
          getAllShadowRoots(Array.from(el.shadowRoot.querySelectorAll('*')));
        }
      });
    };
    
    getAllShadowRoots(Array.from(document.querySelectorAll('*')));
    console.log("找到Shadow DOM数量:", shadowRoots.length);
    
    for (let i = 0; i < shadowRoots.length; i++) {
      const shadowInput = shadowRoots[i].querySelector('.message-input');
      console.log(`Shadow DOM[${i}]中输入框:`, shadowInput);
      
      if (shadowInput) {
        input = shadowInput;
        console.log("在Shadow DOM中找到输入框");
        break;
      }
    }
  }
  
  if (!input) {
    console.log("未找到输入框");
    return;
  }
  
  console.log("找到输入框:", input);
  
  // 继续原有的queryServer逻辑
  console.log("32432432",324324324);
const url = "https://live2.tingwu.co/wsttsgpt.php";
const data = {
  type: "query",
  apikey: savedApikey
};

fetch(url, {
  method: "POST",
  headers: {
    'Content-Type': 'application/json'
  },
  body: JSON.stringify(data)
})
.then(response => response.json()) 
.then(data => {
  if (data.code === 10000) {
      const contents = data.data;
      const id = contents['id'];
      const apikey = contents['apikey']; 
      const nickname = contents['nickname'];
      const question = contents['question'];
      const answer = contents['answer'];
      const pintai = contents['pintai'];

      if(pintai == 'sph'){
          // 抖音,把内容输入到输入框
        
         
          if(input){
              input.dispatchEvent(new InputEvent('input', { bubbles: true }));
              input.value = answer;
              input.dispatchEvent(new InputEvent('change', { bubbles: true }));
              // 等待
              setTimeout(() => {
                  // 创建并触发回车事件
                  const enterEvent = new KeyboardEvent('keydown', {
                      bubbles: true,
                      cancelable: true,
                      keyCode: 13,
                      which: 13,
                      key: 'Enter'
                  });
                  input.dispatchEvent(enterEvent);
              }, 200);
              input.dispatchEvent(new InputEvent('input', { bubbles: true }));
              input.value = "";
              input.dispatchEvent(new InputEvent('change', { bubbles: true }));
          }
      }
  }
})
.catch(error => {
  console.error("请求失败:", error);
});
}
  chrome.storage.local.get(['selectedFeaturesph']).then(result => {
    if(result.selectedFeaturesph == 'sph'){
     
        setInterval(queryServer, 2000);
    }
}) ;


  chrome.storage.local.get(['selectedFeaturedanmu']).then(result => {




    if(result.selectedFeaturedanmu == 'danmu'){


       

        // 初始获取数据
        fetchLiveData();

        // 设置定时器，定期获取直播间数据
        const dataInterval = setInterval(fetchLiveData, 5000); // 每5秒获取一次数据
        
        // 监听评论信息
        function fetchComments() {
        //  console.log("获取评论数据...");
          
          // 初始化seen集合（如果不存在）
          if (typeof window.seen === 'undefined') {
            // 尝试从localStorage恢复seen集合
            const seenFromStorage = localStorage.getItem('seenComments');
            window.seen = seenFromStorage ? new Set(JSON.parse(seenFromStorage)) : new Set();
           // console.log("初始化seen集合，当前大小:", window.seen.size);
          }
          
          // 尝试查找iframe
          const iframes = document.querySelectorAll('iframe');
          //console.log("页面中iframe数量:", iframes.length);
          
          // 尝试在主文档中查找
          let messageItems = document.querySelectorAll(".live-message-item");
        //  console.log("主文档中消息元素数量:", messageItems.length);
          
          // 如果主文档中没找到，尝试在所有iframe中查找
          if (messageItems.length === 0 && iframes.length > 0) {
            for (let i = 0; i < iframes.length; i++) {
              try {
                const frameDoc = iframes[i].contentDocument || iframes[i].contentWindow.document;
                const frameMessages = frameDoc.querySelectorAll(".live-message-item");
              //  console.log(`iframe[${i}]中消息元素数量:`, frameMessages.length);
                
                if (frameMessages.length > 0) {
                  messageItems = frameMessages;
                  console.log("在iframe中找到消息元素");
                  break;
                }
              } catch (e) {
                console.log(`无法访问iframe[${i}]内容:`, e.message);
              }
            }
          }
          
          // 尝试查找Shadow DOM
          if (messageItems.length === 0) {
          //  console.log("尝试在Shadow DOM中查找");
            const shadowRoots = [];
            const getAllShadowRoots = (elements) => {
              elements.forEach(el => {
                if (el.shadowRoot) {
                  shadowRoots.push(el.shadowRoot);
                  getAllShadowRoots(Array.from(el.shadowRoot.querySelectorAll('*')));
                }
              });
            };
            
            getAllShadowRoots(Array.from(document.querySelectorAll('*')));
           // console.log("找到Shadow DOM数量:", shadowRoots.length);
            
            for (let i = 0; i < shadowRoots.length; i++) {
              const shadowMessages = shadowRoots[i].querySelectorAll(".live-message-item");
             // console.log(`Shadow DOM[${i}]中消息元素数量:`, shadowMessages.length);
              
              if (shadowMessages.length > 0) {
                messageItems = shadowMessages;
             //   console.log("在Shadow DOM中找到消息元素");
                break;
              }
            }
          }
          
          if (messageItems.length === 0) {
          //  console.log("未找到消息元素");
            return;
          }
          
         // console.log(`找到 ${messageItems.length} 条消息`);
          
          const comments = Array.from(messageItems)
            .map((item) => {
              const type = item.querySelector(".message-type")?.innerText || "";
              const username = item.querySelector(".message-username-desc")?.innerText.replace(":", "") || "";
              const content = item.querySelector(".message-content")?.innerText || "";
              const timestamp = new Date().toLocaleString("zh-CN", { hour12: false }).replace(/\//g, "-");
              
              const commentId = `${type}-${username}-${content}`;
              
              if (window.seen.has(commentId)) {
               // console.log("已评论：", commentId);
                return null;
              } else {
                //console.log("没评论：", commentId);
                window.seen.add(commentId);
                // 更新localStorage中的seen集合
                localStorage.setItem('seenComments', JSON.stringify(Array.from(window.seen)));
                const commentType = type || (username ? "评论" : "系统消息");
                
                if (commentType === "评论") {
                  const commentData = {
                    type: commentType,
                    username: username,
                    content: content,
                    comment_time: timestamp
                  };
                  const liveDatas = JSON.parse(localStorage.getItem('liveDatas')) || [];
                  // 组合数据到一个数组
                  const datas = {
                    error: 0,
                    comments: [commentData],
                    join_info: [],
                    online_users: liveDatas
                  };
                  //console.log("发送数据到ws服务11111111");
                  // 发送数据到ws服务
                  sendMessage_ws(datas);
                  //console.log("发送数据到ws服务22222222");
                  // 添加调试信息
                  //console.log("准备更新日志:", username, content);
                  try {
                    // 更新日志区域
                    updateLogArea(`${username}: ${content}`, "评论");
                   // console.log("日志更新成功");
                  } catch (error) {
                    console.error("更新日志时出错:", error);
                  }
                  
                  return {
                    type: commentType,
                    username,
                    content,
                    timestamp,
                  };
                } else {
                  // 对于非评论类型的消息也更新日志
                  try {
                    updateLogArea(`${type ? type + ': ' : ''}${username ? username + ': ' : ''}${content}`, type || "系统消息");
                  } catch (error) {
                    console.error("更新非评论日志时出错:", error);
                  }
                }
                
                return {
                  type: commentType,
                  username,
                  content,
                  timestamp,
                };
              }
            })
            .filter((comment) => comment !== null);
          
          console.log("评论数据:", JSON.stringify(comments, null, 2));
        }
        
        // 定时获取评论数据
        const commentsInterval = setInterval(fetchComments, 3000); // 每3秒获取一次评论
        
        // 初始获取评论数据
        fetchComments();

        
        
        // 处理加入消息的辅助函数
        function processJoinMessages(container) {
          const joinMessages = container.querySelectorAll('.live-join-message');
          if (!joinMessages || joinMessages.length === 0) {
            console.log('未找到加入消息元素');
            return [];
          }
          
          const messages = [];
          joinMessages.forEach(message => {
            const nicknameElement = message.querySelector('.nickname');
            if (nicknameElement && nicknameElement.textContent.trim()) {
              messages.push({
                nickname: nicknameElement.textContent.trim(),
                time: new Date().toISOString()
              });
            }
          });
          
          return messages;
        }
        
        // 获取直播间用户信息
        function fetchLiveData() {
          try {
           //console.log("获取直播间用户数据...");
            
            // 初始化seenUsers集合（如果不存在）
            if (typeof window.seenUsers === 'undefined') {
              // 尝试从localStorage恢复seenUsers集合
              const seenFromStorage = localStorage.getItem('seenUsers');
              window.seenUsers = seenFromStorage ? new Set(JSON.parse(seenFromStorage)) : new Set();
           //   console.log("初始化seenUsers集合，当前大小:", window.seenUsers.size);
            }
            
            // 尝试查找iframe
            const iframes = document.querySelectorAll('iframe');
            //console.log("页面中iframe数量:", iframes.length);
            
            // 尝试在主文档中查找
            let userItems = document.querySelectorAll(".live-gift-list-item");
          //  console.log("主文档中用户元素数量:", userItems.length);
            
            // 如果主文档中没找到，尝试在所有iframe中查找
            if (userItems.length === 0 && iframes.length > 0) {
              for (let i = 0; i < iframes.length; i++) {
                try {
                  const frameDoc = iframes[i].contentDocument || iframes[i].contentWindow.document;
                  const frameUsers = frameDoc.querySelectorAll(".live-gift-list-item");
                 // console.log(`iframe[${i}]中用户元素数量:`, frameUsers.length);
                  
                  if (frameUsers.length > 0) {
                    userItems = frameUsers;
                   // console.log("在iframe中找到用户元素");
                    break;
                  }
                } catch (e) {
                  console.log(`无法访问iframe[${i}]内容:`, e.message);
                }
              }
            }
            
            // 尝试查找Shadow DOM
            if (userItems.length === 0) {
            //  console.log("尝试在Shadow DOM中查找");
              const shadowRoots = [];
              const getAllShadowRoots = (elements) => {
                elements.forEach(el => {
                  if (el.shadowRoot) {
                    shadowRoots.push(el.shadowRoot);
                    getAllShadowRoots(Array.from(el.shadowRoot.querySelectorAll('*')));
                  }
                });
              };
              
              getAllShadowRoots(Array.from(document.querySelectorAll('*')));
             // console.log("找到Shadow DOM数量:", shadowRoots.length);
              
              for (let i = 0; i < shadowRoots.length; i++) {
                const shadowUsers = shadowRoots[i].querySelectorAll(".live-gift-list-item");
              //  console.log(`Shadow DOM[${i}]中用户元素数量:`, shadowUsers.length);
                
                if (shadowUsers.length > 0) {
                  userItems = shadowUsers;
              //    console.log("在Shadow DOM中找到用户元素");
                  break;
                }
              }
            }
            
            if (userItems.length === 0) {
            //  console.log("未找到用户元素");
              return null;
            }
            
           // console.log(`找到 ${userItems.length} 个用户`);
            
            // 处理用户数据
            const onlineUserData = Array.from(userItems).map(user => {
              try {
                const name = user.querySelector(".text-wrap")?.innerText || "未知用户";
                const gender = user.querySelector(".svg-icon")
                  ? user.querySelector(".svg-icon").classList.contains("girl")
                    ? "女"
                    : "男"
                  : "未知";
                const value = user.querySelector(".live-gift-list-item-content-value")?.innerText || "0";
                
                return {
                  name,
                  gender,
                  value
                };
              } catch (e) {
                console.error("处理用户元素时出错:", e);
                return null;
              }
            }).filter(item => item !== null);
            
            // 将数据存入缓存
            localStorage.setItem('liveDatas', JSON.stringify(onlineUserData));
            
            // 组合数据到一个数组
            const datas = {
              error: 0,
              comments: [],
              join_info: [],
              online_users: onlineUserData
            };
            
            // 发送数据到ws服务
            sendMessage_ws(datas);
            
            // 记录在线用户日志
            onlineUserLogs(JSON.stringify(onlineUserData, null, 2));
            
           // console.log("在线用户数据:", JSON.stringify(onlineUserData, null, 2));
            
            return {
              users: onlineUserData,
              totalUsers: onlineUserData.length,
              time: new Date().toISOString()
            };
          } catch (error) {
            console.error('获取直播数据失败:', error);
            return null;
          }
        }
        
        // 记录在线用户日志的函数
        async function onlineUserLogs(contents) {
          try {
            const savedApikey = localStorage.getItem('apikey') || '';
            const url = "https://live2.tingwu.co/sphapi.php?action=add_online_user_log&apikey=" + savedApikey;
            const formData = new FormData();
            formData.append("contents", contents);
            const controller = new AbortController();
            
            const response = await fetch(url, {
              method: "POST",
              body: formData,
              signal: controller.signal,
            });
            
            if (!response.ok) {
              throw new Error(`HTTP error! status: ${response.status}`);
            }
            
            const data = await response.json();
            if (data.error === 0) {
              // 更新 log_area 的内容
              updateLogArea(contents, "在线用户");
            }
          } catch (error) {
            console.error('记录在线用户日志失败:', error);
          }
        }
        
        // 获取加入消息的函数
        function fetchJoinMessages() {
          try {
            console.log("获取加入消息数据...");
            
            // 初始化seenJoinMessages集合（如果不存在）
            if (typeof window.seenJoinMessages === 'undefined') {
              // 尝试从localStorage恢复seenJoinMessages集合
              const seenFromStorage = localStorage.getItem('seenJoinMessages');
              window.seenJoinMessages = seenFromStorage ? new Set(JSON.parse(seenFromStorage)) : new Set();
              console.log("初始化seenJoinMessages集合，当前大小:", window.seenJoinMessages.size);
            }
            
            // 尝试查找iframe
            const iframes = document.querySelectorAll('iframe');
            console.log("页面中iframe数量:", iframes.length);
            
            // 尝试在主文档中查找
            let joinMessageContainers = document.querySelectorAll(".live-join-message-container");
            console.log("主文档中加入消息容器数量:", joinMessageContainers.length);
            
            // 如果主文档中没找到，尝试在所有iframe中查找
            if (joinMessageContainers.length === 0 && iframes.length > 0) {
              for (let i = 0; i < iframes.length; i++) {
                try {
                  const frameDoc = iframes[i].contentDocument || iframes[i].contentWindow.document;
                  const frameJoinContainers = frameDoc.querySelectorAll(".live-join-message-container");
                  console.log(`iframe[${i}]中加入消息容器数量:`, frameJoinContainers.length);
                  
                  if (frameJoinContainers.length > 0) {
                    joinMessageContainers = frameJoinContainers;
                    console.log("在iframe中找到加入消息容器");
                    break;
                  }
                } catch (e) {
                  console.log(`无法访问iframe[${i}]内容:`, e.message);
                }
              }
            }
            
            // 尝试查找Shadow DOM
            if (joinMessageContainers.length === 0) {
              console.log("尝试在Shadow DOM中查找");
              const shadowRoots = [];
              const getAllShadowRoots = (elements) => {
                elements.forEach(el => {
                  if (el.shadowRoot) {
                    shadowRoots.push(el.shadowRoot);
                    getAllShadowRoots(Array.from(el.shadowRoot.querySelectorAll('*')));
                  }
                });
              };
              
              getAllShadowRoots(Array.from(document.querySelectorAll('*')));
              console.log("找到Shadow DOM数量:", shadowRoots.length);
              
              for (let i = 0; i < shadowRoots.length; i++) {
                const shadowJoinContainers = shadowRoots[i].querySelectorAll(".live-join-message-container");
                console.log(`Shadow DOM[${i}]中加入消息容器数量:`, shadowJoinContainers.length);
                
                if (shadowJoinContainers.length > 0) {
                  joinMessageContainers = shadowJoinContainers;
                  console.log("在Shadow DOM中找到加入消息容器");
                  break;
                }
              }
            }
            
            if (joinMessageContainers.length === 0) {
              console.log("未找到加入消息容器");
              return null;
            }
            
            console.log(`找到 ${joinMessageContainers.length} 个加入消息容器`);
            
            // 处理加入消息数据
            const joinData = Array.from(joinMessageContainers).map(container => {
              try {
                const nicknameElement = container.querySelector(".nickname");
                if (!nicknameElement) return null;
                
                const nickname = nicknameElement.textContent.trim();
                if (!nickname) return null;
                
                // 检查是否已经处理过这个用户
                if (window.seenJoinMessages.has(nickname)) return null;
                
                // 添加到已处理集合
                window.seenJoinMessages.add(nickname);
                
                // 获取当前时间戳
                const timestamp = new Date()
                  .toLocaleString("zh-CN", { hour12: false })
                  .replace(/\//g, "-");
                
                // 创建加入信息对象
                const joinInfo = {
                  nickname,
                  user_action: "进入直播间",
                  timestamp
                };
                
                // 获取直播数据
                const liveDatas = JSON.parse(localStorage.getItem('liveDatas')) || null;
                
                // 组合数据到一个数组
                const datas = {
                  error: 0,
                  comments: [],
                  join_info: [joinInfo],
                  online_users: liveDatas
                };
                
                // 发送数据到ws服务
                sendMessage_ws(datas);
                
                // 记录加入日志
                JoinLogs(nickname, "进入直播间", timestamp);
                
                return joinInfo;
              } catch (e) {
                console.error("处理加入消息元素时出错:", e);
                return null;
              }
            }).filter(item => item !== null);
            
            // 保存seenJoinMessages到localStorage
            localStorage.setItem('seenJoinMessages', JSON.stringify([...window.seenJoinMessages]));
            
            if (joinData.length > 0) {
              console.log("用户进入直播间:", JSON.stringify(joinData, null, 2));
            }
            
            return {
              joinedUsers: joinData,
              totalJoinedUsers: window.seenJoinMessages.size,
              time: new Date().toISOString()
            };
          } catch (error) {
            console.error('获取加入消息数据失败:', error);
            return null;
          }
        }
        
        // 记录加入日志的函数
        async function JoinLogs(nickname, user_action, timestamp) {
          try {
            const savedApikey = localStorage.getItem('apikey') || '';
            const url = "https://live2.tingwu.co/sphapi.php?action=add_join_log&apikey=" + savedApikey;
            const formData = new FormData();
            formData.append("nickname", nickname);
            formData.append("user_action", user_action);
            formData.append("timestamp", timestamp);
            const controller = new AbortController();

            const response = await fetch(url, {
              method: "POST",
              body: formData,
              signal: controller.signal,
            });
            
            if (!response.ok) {
              throw new Error(`HTTP error! status: ${response.status}`);
            }
            
            const data = await response.json();
            if (data.error === 0) {
              // 更新 log_area 的内容
              updateLogArea(JSON.stringify({ nickname, user_action, timestamp }, null, 2), "新进入直播间用户");
            }
          } catch (error) {
            console.error('记录加入日志失败:', error);
          }
        }
        
        // 设置MutationObserver监听页面变化
        function setupLiveDataObserver() {
          console.log("设置直播数据观察器...");
          const observer = new MutationObserver(() => {
            fetchLiveData();
            fetchJoinMessages();
          });
          
          observer.observe(document.body, { childList: true, subtree: true });
          console.log("直播数据观察器已设置");
          
          // 初始获取一次数据
          fetchLiveData();
          fetchJoinMessages();
        }

        // 页面加载完成后设置观察器
        window.addEventListener('load', () => {
          console.log("页面加载完成，准备设置观察器...");
          setTimeout(setupLiveDataObserver, 3000); // 延迟3秒启动，确保页面元素已加载
        });

        // 移除原有的MutationObserver，改用定时器
        // 如果之前有定义这些Observer，需要断开连接
        if (typeof commentsObserver !== 'undefined') {
          commentsObserver.disconnect();
        }
        if (typeof joinObserver !== 'undefined') {
          joinObserver.disconnect();
        }

        // 清除原有的检查间隔
        if (typeof checkInterval !== 'undefined') {
          clearInterval(checkInterval);
        }

        // 页面卸载时清除所有定时器
        window.addEventListener('beforeunload', () => {
          clearInterval(dataInterval);
          clearInterval(commentsInterval);
         
        });




    }
  }) ;


   

 



});








